'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var buttonStyles = {
  cursor: 'pointer',
  fontWeight: 'bold',
  borderRadius: '3px',
  padding: '4px',
  margin: '5px 3px',
  fontSize: '0.8em',
  color: 'white',
  textDecoration: 'none',
  backgroundColor: '#4F5A65',
  border: 'none',
  position: 'absolute',
  bottom: '3px',
  right: '5px'
};

var contentStyles = {
  background: '#2A2F3A',
  margin: '5px',
  padding: '5px',
  borderRadius: '3px',
  outline: 'none',
  color: 'white',
  overflow: 'auto'
};

var Dispatcher = (function (_Component) {
  _inherits(Dispatcher, _Component);

  function Dispatcher(props, context) {
    _classCallCheck(this, Dispatcher);

    return _possibleConstructorReturn(this, _Component.call(this, props, context));
  }

  Dispatcher.prototype.launchAction = function launchAction() {
    this.context.store.dispatch(JSON.parse(this.refs.action.textContent.replace(/\s+/g, ' ')));
  };

  Dispatcher.prototype.componentDidMount = function componentDidMount() {
    this.refs.action.innerHTML = this.props.initEmpty ? '<br/>' : '{<br/>"type": ""<br/>}';
  };

  Dispatcher.prototype.render = function render() {
    return _react2.default.createElement(
      'div',
      { style: { background: '#4F5A65', fontFamily: 'monaco,Consolas,Lucida Console,monospace' } },
      _react2.default.createElement('div', { contentEditable: 'true', style: contentStyles, ref: 'action' }),
      _react2.default.createElement(
        'button',
        { style: buttonStyles, onClick: this.launchAction.bind(this) },
        'Dispatch'
      )
    );
  };

  return Dispatcher;
})(_react.Component);

Dispatcher.contextTypes = {
  store: _react.PropTypes.object
};

Dispatcher.update = function () {};

exports.default = Dispatcher;